<template>
  <v-row justify="center">
    <v-col cols="12" sm="10" md="8" lg="6">
      <v-card ref="form">
        <v-card-text>
          <v-text-field
            ref="name"
            v-model="name"
            :rules="[() => !!name || 'Este campo es requerido']"
            :error-messages="errorMessages"
            label="Nombre"
            placeholder="Nombre"
            required
          ></v-text-field>
          <v-text-field
            ref="last_name"
            v-model="last_name"
            :error-messages="errorMessages"
            label="Apellido(s)"
            placeholder="Apellido(s)"
          ></v-text-field>
          <v-text-field
            ref="email"
            v-model="email"
            :rules="[() => !!email || 'Este campo es requerido']"
            :error-messages="errorMessages"
            label="Email"
            placeholder="Email"
            required
          ></v-text-field>
          <v-text-field
            v-model="password"
            :append-icon="show1 ? 'mdi-eye' : 'mdi-eye-off'"
            :rules="[
                () => !!password ||'Este campo es requerido',
                () => !!password && password.length >= 8 || 'Tus contraseña es menor a 8 caracteres']"
            :type="show1 ? 'text' : 'password'"
            name="input-10-1"
            label="Contraseña"
            hint="Tu contraseña cumple con los 8 caracteres"
            counter
            @click:append="show1 = !show1"
          ></v-text-field>
          <v-text-field
            ref="street"
            v-model="street"
            :rules="[   
              () => !!street || 'Este campo es requerido',
            ]"
            label="Calle"
            placeholder="Calle"
            required
          ></v-text-field>
          <v-text-field
            ref="bloc"
            v-model="bloc"
            :rules="[   
              () => !!bloc || 'Este campo es requerido',
            ]"
            label="Colonia"
            placeholder="Colonia"
            required
          ></v-text-field>
          <v-text-field
            ref="phone"
            v-model="phone"
            :rules="[() => !!phone || 'Este campo es requerido']"
            label="Teléfono"
            placeholder="Teléfono"
            required
          ></v-text-field>
          <v-text-field
            ref="zip"
            v-model="zip"
            :rules="[() => !!zip || 'Este campo es requerido']"
            label="Codigo Postal"
            required
            placeholder="Código Postal"
          ></v-text-field>
          <v-autocomplete
            ref="role"
            v-model="role"
            :rules="[() => !!role || 'Este campo es requerido']"
            :items="roles"
            label="Tipo de Usuario"
            placeholder="Select..."
            required
          ></v-autocomplete>
          <v-autocomplete
            ref="market"
            v-model="market"
            :rules="[() => !!market || 'Este campo es requerido']"
            :items="markets"
            label="Mercado"
            placeholder="Select..."
            required
          ></v-autocomplete>
        </v-card-text>
        <v-divider class="mt-12"></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-slide-x-reverse-transition>
            <v-tooltip
              v-if="formHasErrors"
              left
            >
            <template>
                <!-- Aqui va el logo -->
            </template>
              <template v-slot:activator="{ on }">
                <v-btn
                  icon
                  class="my-0"
                  @click="resetForm"
                  v-on="on"
                >
                  <v-icon>mdi-refresh</v-icon>
                </v-btn>
              </template>
              <span>Refresh form</span>
            </v-tooltip>
          </v-slide-x-reverse-transition>
          <v-btn color="primary" text @click="submit">Registrar </v-btn>
        </v-card-actions>
      </v-card>
    </v-col>
  </v-row>
</template>


<script>
  export default {
    data: () => ({
      roles: ['Administrador', 'Agente'],
      markets: ['Feria', 'SEP'],
      email:null,
      errorMessages: '',
      last_name:null,
      name: null,
      password: null,
      show1: false,
      street:null,
      phone:null,
      address: null,
      bloc:null,
      city: null,
      zip: null,
      market: null,
      role: null,
      formHasErrors: false,
    }),

    computed: {
      form () {
        return {
          name: this.name,
          password: this.password,
          address: this.address,
          email: this.email,
          city: this.city,
          zip: this.zip,
          market: this.market,
          role: this.role,
          last_name: this.last_name,
          phone: this.phone,
          bloc: this.bloc
        }
      },
    },

    watch: {
      name () {
        this.errorMessages = ''
      },
    },

    methods: {
      addressCheck () {
        this.errorMessages = this.address && !this.name
          ? 'Hey! I\'m required'
          : ''

        return true
      },
      resetForm () {
        this.errorMessages = []
        this.formHasErrors = false

        Object.keys(this.form).forEach(f => {
          this.$refs[f].reset()
        })
      },
      async submit () {
        this.formHasErrors = false
        let userData = Object(this.form);
        let data = {
          email : userData.email,
          password : userData.password,
          data : {
            bloc : userData.bloc,
            email : userData.email,
            name : userData.name,
            last_name : userData.last_name,
            phone : userData.phone,
            postal_code : userData.zip,
            street : userData.street,
            role : userData.role,
            market : userData.market
          }
        }
        console.log(data)
        const datos = await this.$axios.post(`http://${process.env.VUE_APP_API_URL}/api/users/admin`, data)
        console.log(datos)
      },
    },
  }
</script>